#include <meko.h>

#include <stdio.h>

#include <gtk/gtkmain.h>
#include <gtk/gtksignal.h>
#include <gtk/gtkwidget.h>
#include <gtk/gtkcontainer.h>
#include <gtk/gtkwindow.h>
#include <gtk/gtkbox.h>
#include <gtk/gtkvbox.h>
#include <libgnome/gnome-defs.h>
#include <libgnome/gnome-i18n.h>
#include <libgnomeui/gnome-init.h>

#include "say2/say2-user.h"
#include "widgets/status-menu/meko-status-menu.h"

static void
_status_changed_cb(MekoStatusMenu *status_menu, gpointer user_data)
{
	Say2UserStatus status;
	Say2User *user;

	status = meko_status_menu_get_value(status_menu);
	user = meko_status_menu_get_user(status_menu);

	gtk_object_set(GTK_OBJECT(user), "status", status, NULL);
}

static void
_button_clicked_cb(GtkWidget *widget, Say2User *user)
{
	gtk_object_set(GTK_OBJECT(user), "nick", "Keyb|AWAY",
		       "status", SAY2_USER_AWAY, NULL);
}

int
main(int argc, char *argv[])
{
	GtkWidget   *win, *box, *wid;
	Say2User    *user;

	FILE	    *fd;
	char	     icon[4096];
	int	     icon_sz;

	bindtextdomain(PACKAGE, MEKO_LOCALEDIR);
	textdomain(PACKAGE);

	gnome_init(APPNAME, VERSION, argc, argv);

	fd = fopen("/home/scott/me-say2.png", "r");
	icon_sz = fread(icon, 1, sizeof(icon), fd);
	fclose(fd);

	user = SAY2_USER(gtk_object_new(
		SAY2_TYPE_USER,
		"id", "keybuk",
		"guest", FALSE,
		"nick", "Keybuk",
		"email", "scott@netsplit.com",
		"tagline", "Saving the world from disaster since 1980!",
		"client", "Meko 0.10.0",
		"host", "localhost",
		"status", SAY2_USER_BUSY,
		"status_msg", "Programming more of Meko",
		"status_time", time(NULL),
		NULL
	));
	say2_client_set_icon(SAY2_CLIENT(user), icon, icon_sz);

	win = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	box = gtk_vbox_new(FALSE, 8);
	gtk_container_set_border_width(GTK_CONTAINER(box), 16);
	gtk_container_add(GTK_CONTAINER(win), box);
	gtk_widget_show(box);

	wid = meko_status_menu_new(user);
	gtk_box_pack_start(GTK_BOX(box), wid, FALSE, FALSE, 0);
	gtk_signal_connect(GTK_OBJECT(wid), "changed",
			   GTK_SIGNAL_FUNC(_status_changed_cb), NULL);
	gtk_widget_show(wid);

	wid = gtk_button_new_with_label("Change user");
	gtk_box_pack_start(GTK_BOX(box), wid, FALSE, FALSE, 0);
	gtk_signal_connect(GTK_OBJECT(wid), "clicked",
			   GTK_SIGNAL_FUNC(_button_clicked_cb), user);
	gtk_widget_show(wid);

	gtk_widget_show(win);

	gtk_main();

	return 0;
}
